---

- name: Ensure config-directory exist
  file: path={{ elasticsearch_serviced_conf_dir }} state=directory
    
- name: Add override.conf of serviced
  template:
    src: "serviced-override.conf.j2"
    dest: "{{ elasticsearch_serviced_conf_dir }}/override.conf"
    mode: 0644
  notify: restart elasticsearch
  register: elasticsearch_systemd_config_result
  
- name: reload systemd
  systemd: daemon_reload=yes
  when: elasticsearch_systemd_config_result.changed

# have to exist before elasticsearch installation
- name: Ensures elasticsearch backup directory exist
  become: true
  file:
    path: '{{ search_index_data_backup_directory }}/elasticsearch'
    state: directory

- include_role:
    name: geerlingguy.elasticsearch
  vars:
    elasticsearch_network_host: "{{ elasticsearch_host }}"
    elasticsearch_http_port: "{{ elasticsearch_port }}"
    elasticsearch_extra_options: |
      xpack.security.enabled: true
      action.destructive_requires_name: true
      path:
        repo:
          - "{{ search_index_data_backup_directory }}/elasticsearch"

# file permission has to be changed after elasticsearch user was created
- name: Ensures elasticsearch has write access to backup directory
  become: true
  file:
    path: '{{ search_index_data_backup_directory }}/elasticsearch'
    state: directory
    owner: "elasticsearch"
    group: "{{ search_index_user }}"
    mode: "0770"

- name: Add wait for script
  template:
    src: "wait-for-elasticsearch.sh.j2"
    dest: "{{ base_dir }}/bin/wait-for-elasticsearch.sh"
    owner: "{{ search_index_user }}"
    group: "{{ search_index_user }}"
    mode: 0700

- include_tasks: users.yml
- include_tasks: index.yml
